import * as Actions from "./actions";
import { Debugger } from "./actions/Debugger";
import { IActionData } from "./actions/interfaces";
import { IActionFunctionData } from "./functions/interfaces";
import { ActionFunction } from "./functions/ActionFunction";
export interface IBuilderJSON {
    actions: IActionData[];
    functions?: IActionFunctionData[];
    name?: string;
    comments?: string;
    debugger?: any;
}
export declare class CCMLBuilder {
    private json;
    private _debugger;
    private _lastCallbackResponseName;
    private _actionConstructors;
    private _functions;
    private _actions;
    constructor(json: IBuilderJSON, _debugger?: Debugger | undefined);
    getJSONActionsWithIDs(): IBuilderJSON;
    getActions(): Array<Actions.IAction>;
    addActions(...data: IActionData[]): CCMLBuilder;
    getFunctions(): Array<ActionFunction>;
    addFunctions(...funcs: IActionFunctionData[]): CCMLBuilder;
    build(env?: "dev" | "qa" | "prod", isModule?: boolean): string;
    private eventCCMLBuilder(actions, name?);
    private callActionConstructor(d);
    private buildCCML(data);
    private buildCollect(data);
    private buildConference(data);
    private buildDetect(data);
    private buildDial(data);
    private buildForEach(data);
    private buildFunction(data);
    private buildGoogleAnalytics(data);
    private buildGoto(data);
    private buildHangUp(data);
    private buildIf(data);
    private buildLabel(data);
    private buildPause(data);
    private buildPlay(data);
    private buildQueue(data);
    private buildRecord(data);
    private buildRecordMessage(data);
    private buildRedirect(data);
    private buildReject(data);
    private buildSay(data);
    private buildSessionData(data);
    private buildSMS(data);
    private buildStop(data);
    private buildTransfer(data);
    private buildVar(data);
    private buildWebhook(data);
}
