"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var Collect = (function (_super) {
    __extends(Collect, _super);
    function Collect(name) {
        if (name === void 0) { name = "action" + (++Collect._counter); }
        var _this = _super.call(this, {
            type: "COLLECT",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("collect"),
                varName: "collect_keys_" + name,
                num_digits: "1",
                finish_on_key: "pound",
                digits_only: "false",
                enforce_end: "true"
            }
        }) || this;
        _this.name = name;
        _this._paramMap = {
            id: "id",
            varName: "varName",
            num_digits: "maxKeys",
            finish_on_key: "endKey",
            digits_only: "digitsOnly",
            enforce_end: "enforceEndOnMax"
        };
        _this._timeout = 5000;
        _this._groupActions = [];
        _this.type = interfaces_1.Type.Collect;
        return _this;
    }
    Object.defineProperty(Collect.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Collect.prototype, "numDigits", {
        get: function () {
            return +this.getParam("num_digits");
        },
        set: function (num) {
            this.setParam("num_digits", String(num));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Collect.prototype, "finishOnKey", {
        get: function () {
            var key = this.getParam("finish_on_key");
            switch (key) {
                case "hash":
                case "pound": return "#";
                case "star": return "*";
                case "": return "off";
                default: return key;
            }
        },
        set: function (key) {
            key = String(key).toLowerCase();
            if (key === "#") {
                key = "pound";
            }
            else if (key === "*") {
                key = "star";
            }
            else if (key === "off") {
                key = "";
            }
            this.setParam("finish_on_key", key);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Collect.prototype, "digitsOnly", {
        get: function () {
            return this.getParam("digits_only") === "true";
        },
        set: function (key) {
            this.setParam("digits_only", String(key));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Collect.prototype, "timeout", {
        get: function () {
            return +this._timeout;
        },
        set: function (ms) {
            this._timeout = +ms;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Collect.prototype, "actions", {
        get: function () {
            return this._groupActions;
        },
        set: function (actions) {
            this._groupActions = actions
                .filter(function (a) { return a.type === interfaces_1.Type.Play || a.type === interfaces_1.Type.Say || a.type === interfaces_1.Type.Pause || a.type === interfaces_1.Type.Debugger; })
                .map(function (a) {
                if ("stopOnKey" in a) {
                    a.stopOnKey = true;
                }
                return a;
            });
        },
        enumerable: true,
        configurable: true
    });
    Collect.prototype.toCCML = function () {
        var id = interfaces_1.CoreAction.genId();
        var ccml = [];
        ccml.push("<SET varName=\"___collectAttempt_" + id + "___\" evaluate=\"true\" export=\"false\" value=\"1 + (${___collectAttempt_" + id + "___} | 0)\"/>");
        ccml.push("<SET varName=\"___localVar_collectAttempt___\" export=\"false\" value=\"${___collectAttempt_" + id + "___}\"/>");
        if (this._groupActions.length > 0) {
            this._groupActions.forEach(function (a) { return ccml.push(a.toCCML("sets")); });
            ccml.push("<GROUP repeatMax=\"0\">");
            this._groupActions.filter(function (a) { return a.type !== interfaces_1.Type.Debugger; }).forEach(function (a) { return ccml.push(a.toCCML("says")); });
            ccml.push("</GROUP>");
        }
        ccml.push("<COLLECT" + _super.prototype.toCCML.call(this, this._paramMap) + ">");
        ccml.push("<TIMER milliSeconds=\"" + this._timeout + "\" nextActionId=\"${next}\"/>");
        ccml.push("</COLLECT>");
        ccml.push("<SET varName=\"___lastCollectKeys___\" evaluate=\"true\" value=\"${" + this.getParam("varName") + "} || ''\" export=\"false\"/>");
        ccml.push("<SET varName=\"collect_keys\" value=\"${collect_keys}" + this.name + "=${" + this.getParam("varName") + "}&amp;\" export=\"true\"/>");
        return ccml.join("");
    };
    Collect._counter = 0;
    return Collect;
}(interfaces_1.CoreAction));
exports.Collect = Collect;
//# sourceMappingURL=Collect.js.map