"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
var ConferenceEvent;
(function (ConferenceEvent) {
    ConferenceEvent[ConferenceEvent["JOIN"] = 0] = "JOIN";
    ConferenceEvent[ConferenceEvent["LEAVE"] = 1] = "LEAVE";
    ConferenceEvent[ConferenceEvent["MUTE"] = 2] = "MUTE";
    ConferenceEvent[ConferenceEvent["UNMUTE"] = 3] = "UNMUTE";
    ConferenceEvent[ConferenceEvent["HOLD"] = 4] = "HOLD";
    ConferenceEvent[ConferenceEvent["RESUME"] = 5] = "RESUME";
})(ConferenceEvent = exports.ConferenceEvent || (exports.ConferenceEvent = {}));
exports.ConferenceOnEvent = {
    OnEnter: "on_enter",
    OnEnterAlone: "on_enter_alone",
    OnEnterStarted: "on_enter_started",
    OnEnterWaiting: "on_enter_waiting",
    OnEnterError: "on_enter_error",
    OnEnterErrorMaxParticipants: "on_enter_error_max_participants",
    OnEnterErrorEnded: "on_enter_error_ended"
};
var Conference = (function (_super) {
    __extends(Conference, _super);
    function Conference(conferenceName, name) {
        if (conferenceName === void 0) { conferenceName = "myConference"; }
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "CONFERENCE",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("conference"),
                event: "join",
                auto_hold: "false",
                join_muted: "false",
                mute_on_key: "off",
                unmute_on_key: "off",
                exit_on_key: "off",
                announce: "none",
                max_participants: "",
                async: "false",
                $onJoin: "start",
                $onLeave: null
            },
            events: (_a = {},
                _a[exports.ConferenceOnEvent.OnEnter] = [],
                _a[exports.ConferenceOnEvent.OnEnterError] = [],
                _a[exports.ConferenceOnEvent.OnEnterErrorEnded] = [],
                _a[exports.ConferenceOnEvent.OnEnterErrorMaxParticipants] = [],
                _a[exports.ConferenceOnEvent.OnEnterAlone] = [],
                _a[exports.ConferenceOnEvent.OnEnterStarted] = [],
                _a[exports.ConferenceOnEvent.OnEnterWaiting] = [],
                _a)
        }) || this;
        _this.conferenceName = conferenceName;
        _this.name = name;
        _this._paramMap = {
            id: "id",
            event: "control",
            auto_hold: "holdAuto",
            join_muted: "joinMuted",
            mute_on_key: "mute",
            unmute_on_key: "unmute",
            exit_on_key: "leave",
            announce: "announce",
            max_participants: "maxParticipants",
            async: "async",
            $onJoin: "onJoin",
            $onLeave: "onLeave"
        };
        _this._holdAudio = [];
        _this.type = interfaces_1.Type.Conference;
        return _this;
        var _a;
    }
    Object.defineProperty(Conference.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "event", {
        get: function () {
            switch (this.getParam("event")) {
                case "join":
                    return ConferenceEvent.JOIN;
                case "leave":
                    return ConferenceEvent.LEAVE;
                case "mute":
                    return ConferenceEvent.MUTE;
                case "unmute":
                    return ConferenceEvent.UNMUTE;
                case "hold":
                    return ConferenceEvent.HOLD;
                case "resume":
                    return ConferenceEvent.RESUME;
                default:
                    return ConferenceEvent.JOIN;
            }
        },
        set: function (evt) {
            this.setParam("event", String(ConferenceEvent[evt]).toLowerCase());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "holdAudio", {
        get: function () {
            return this._holdAudio;
        },
        set: function (url) {
            this._holdAudio = [].concat(url || []);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "async", {
        get: function () {
            return this.getParam("async") === "true";
        },
        set: function (val) {
            this.setParam("async", val ? "true" : "false");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "announceOnJoin", {
        set: function (action) {
            this.setParam("announce", action === "beep" ? "beep" : "none");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "announeOnJoin", {
        get: function () {
            return this.getParam("announce") === "beep" ? "beep" : "none";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "maxParticipants", {
        get: function () {
            return parseInt(this.getParam("max_participants"), 10);
        },
        set: function (val) {
            this.setParam("max_participants", typeof val === "number" ? String(val) : "");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "holdOnJoin", {
        get: function () {
            return this.getParam("$onJoin") === "hold";
        },
        set: function (val) {
            if (val) {
                this.setParam("$onJoin", "hold");
            }
            else if (this.getParam("$onJoin") === "hold") {
                this.setParam("$onJoin", "");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "startOnJoin", {
        get: function () {
            return this.getParam("$onJoin") === "start";
        },
        set: function (val) {
            if (val) {
                this.setParam("$onJoin", "start");
            }
            else if (this.getParam("$onJoin") === "start") {
                this.setParam("$onJoin", "");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "holdOnExit", {
        get: function () {
            return this.getParam("$onLeave") === "hold";
        },
        set: function (val) {
            if (val) {
                this.setParam("$onLeave", "hold");
            }
            else if (this.getParam("$onLeave") === "hold") {
                this.setParam("$onLeave", "");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "endOnExit", {
        get: function () {
            return this.getParam("$onLeave") === "end";
        },
        set: function (val) {
            if (val) {
                this.setParam("$onLeave", "end");
            }
            else if (this.getParam("$onLeave") === "end") {
                this.setParam("$onLeave", "");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "autoHold", {
        get: function () {
            return this.getParam("auto_hold") === "true";
        },
        set: function (val) {
            this.setParam("auto_hold", val ? "true" : "false");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "joinMuted", {
        get: function () {
            return this.getParam("join_muted") === "true";
        },
        set: function (val) {
            this.setParam("join_muted", val ? "true" : "false");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "muteOnKey", {
        get: function () {
            return this.getParam("mute_on_key");
        },
        set: function (key) {
            this.setParam("mute_on_key", String(key));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "unmuteOnKey", {
        get: function () {
            return this.getParam("unmute_on_key");
        },
        set: function (key) {
            this.setParam("unmute_on_key", String(key));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Conference.prototype, "exitOnKey", {
        get: function () {
            return this.getParam("exit_on_key");
        },
        set: function (key) {
            this.setParam("exit_on_key", String(key));
        },
        enumerable: true,
        configurable: true
    });
    Conference.prototype.toCCML = function () {
        var id = interfaces_1.CoreAction.genId();
        var ccml = "";
        var p = utils_1.VarParser.parseVars(this.conferenceName);
        this.conferenceName = p[0];
        ccml += p[1].join("");
        if (this.getParam("event") === "join" &&
            this.events[exports.ConferenceOnEvent.OnEnterAlone].length +
                this.events[exports.ConferenceOnEvent.OnEnterStarted].length +
                this.events[exports.ConferenceOnEvent.OnEnterWaiting].length +
                this.events[exports.ConferenceOnEvent.OnEnter].length > 0) {
            var params = _super.prototype.toCCML.call(this, {
                event: "control",
                auto_hold: "holdAuto",
                mute_on_key: "mute",
                unmute_on_key: "unmute",
                exit_on_key: "leave",
                max_participants: "maxParticipants",
                $onJoin: "onJoin",
            });
            ccml += "\n                <CONFERENCE errorActionId=\"" + id + "_errorHandler\" " + params + " joinMuted=\"true\" async=\"true\">" + this.escapeXml(this.conferenceName) + "</CONFERENCE>\n                <CONDITION>\n                    <WAIT conferenceName=\"" + this.escapeDoubleQuotes(this.conferenceName) + "\" conferenceState=\"START\" nextActionId=\"" + id + "_onEnterStarted\"/>\n                    <WAIT conferenceName=\"" + this.escapeDoubleQuotes(this.conferenceName) + "\" conferenceState=\"END\" nextActionId=\"" + id + "_onEnterErrorEnded\"/>\n                    <WAIT condition=\"true\" nextActionId=\"" + id + "_onEnterWaiting\"/>\n                </CONDITION>\n                <BOOKMARK id=\"" + id + "_onEnterStarted\"/>\n                    " + this.events[exports.ConferenceOnEvent.OnEnterStarted].map(function (e) { return e.toCCML(); }).join("") + "\n                    <WAIT condition=\"true\" nextActionId=\"" + id + "_onEnter\"/>\n                <BOOKMARK id=\"" + id + "_onEnterWaiting\"/>\n                    " + this.events[exports.ConferenceOnEvent.OnEnterWaiting].map(function (e) { return e.toCCML(); }).join("") + "\n                <BOOKMARK id=\"" + id + "_onEnter\"/>\n                    <CONDITION>\n                        <WAIT condition=\"! ${conference.participants} || ${conference.participants} &lt; 2\" nextActionId=\"" + id + "_onEnterAlone\"/>\n                        <WAIT condition=\"true\" nextActionId=\"" + id + "_onEnterDefault\"/>\n                    </CONDITION>\n                    <BOOKMARK id=\"" + id + "_onEnterAlone\"/>\n                        " + this.events[exports.ConferenceOnEvent.OnEnterAlone].map(function (e) { return e.toCCML(); }).join("") + "\n                    <BOOKMARK id=\"" + id + "_onEnterDefault\"/>\n                        " + this.events[exports.ConferenceOnEvent.OnEnter].map(function (e) { return e.toCCML(); }).join("") + "\n            ";
        }
        if (this.getParam("event") === "join" && this.events[exports.ConferenceOnEvent.OnEnterErrorMaxParticipants].length + this.events[exports.ConferenceOnEvent.OnEnterErrorEnded].length + this.events[exports.ConferenceOnEvent.OnEnterError].length > 0) {
            var params = _super.prototype.toCCML.call(this, {
                id: "id",
                event: "control",
                auto_hold: "holdAuto",
                join_muted: "joinMuted",
                mute_on_key: "mute",
                unmute_on_key: "unmute",
                exit_on_key: "leave",
                announce: "announce",
                max_participants: "maxParticipants",
                async: "async",
                $onJoin: "onJoin",
                $onLeave: "onLeave"
            });
            ccml += "<CONFERENCE errorActionId=\"" + id + "_errorHandler\" " + params + ">" + this.escapeXml(this.conferenceName);
            this.holdAudio.forEach(function (url) { return ccml += "<HOLDMUSIC url=\"" + url + "\"/>"; });
            ccml += "</CONFERENCE>";
            ccml += "\n                <WAIT condition=\"true\" nextActionId=\"" + id + "_done\"/>\n                <CONDITION id=\"" + id + "_errorHandler\">\n                    <WAIT error=\"confFull\" nextActionId=\"" + id + "_onEnterErrorMaxParticipants\"/>\n                    <WAIT error=\"confEnded\" nextActionId=\"" + id + "_onEnterErrorEnded\"/>\n                    <WAIT condition=\"true\" nextActionId=\"" + id + "_onEnterError\"/>\n                </CONDITION>\n\n                <BOOKMARK id=\"" + id + "_onEnterErrorMaxParticipants\"/>\n                    " + this.events[exports.ConferenceOnEvent.OnEnterErrorMaxParticipants].map(function (e) { return e.toCCML(); }).join("") + "\n                    <WAIT condition=\"true\" nextActionId=\"" + id + "_onEnterError\"/>\n                <BOOKMARK id=\"" + id + "_onEnterErrorEnded\"/>\n                    " + this.events[exports.ConferenceOnEvent.OnEnterErrorEnded].map(function (e) { return e.toCCML(); }).join("") + "\n                <BOOKMARK id=\"" + id + "_onEnterError\"/>\n                    " + this.events[exports.ConferenceOnEvent.OnEnterError].map(function (e) { return e.toCCML(); }).join("") + "\n                <BOOKMARK id=\"" + id + "_done\"/>\n            ";
        }
        else {
            ccml += "<CONFERENCE errorActionId=\"" + id + "_errorHandler\" " + _super.prototype.toCCML.call(this, this._paramMap) + ">" + this.escapeXml(this.conferenceName);
            this.holdAudio.forEach(function (url) { return ccml += "<HOLDMUSIC url=\"" + url + "\"/>"; });
            ccml += "</CONFERENCE>\n                <BOOKMARK id=\"" + id + "_onEnterErrorEnded\"/><BOOKMARK id=\"" + id + "_errorHandler\"/>\n            ";
        }
        return ccml;
    };
    return Conference;
}(interfaces_1.CoreAction));
exports.Conference = Conference;
//# sourceMappingURL=Conference.js.map