"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
var If_1 = require("./If");
var Say_1 = require("./Say");
var Var_1 = require("./Var");
var Debugger = (function (_super) {
    __extends(Debugger, _super);
    function Debugger(name) {
        if (name === void 0) { name = "debugger"; }
        var _this = _super.call(this, {
            type: "DEBUGGER",
            name: name,
            comments: "",
            params: {},
        }) || this;
        _this.name = name;
        _this._localVars = {};
        _this.type = interfaces_1.Type.Debugger;
        return _this;
    }
    Object.defineProperty(Debugger.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Debugger.prototype, "jsonActions", {
        set: function (js) {
            this._jsonActions = js;
        },
        enumerable: true,
        configurable: true
    });
    Debugger.prototype.toCCML = function (nextAction) {
        var _this = this;
        if (nextAction instanceof Var_1.Var) {
            this._localVars[nextAction.assignmentVar] = utils_1.VarParser.parseExpression(nextAction.expression);
            return "";
        }
        var jsonActionsData = this._jsonActions ?
            "\n                <SET varName=\"debugger_json_actions\" evaluate=\"false\" export=\"false\"><![CDATA[ " + JSON.stringify(this._jsonActions) + " ]]></SET>\n                <SET varName=\"debugger_callback_config\" value=\"${___config___}\" export=\"false\"/>\n            " : "";
        this._jsonActions = undefined;
        var localVarObj = "{" + Object.keys(this._localVars).reduce(function (p, c) { return p + ("\"" + c + "\":" + _this._localVars[c] + ","); }, "").slice(0, -1) + "}";
        var localVarData = "<SET varName=\"debugger_local_var_data\" evaluate=\"true\" export=\"false\"><![CDATA[ JSON.stringify(" + localVarObj + ") ]]></SET>";
        var ifConditionValue = (function () {
            if (nextAction instanceof If_1.If) {
                var ifExpr = utils_1.VarParser.parseExpression(nextAction.condition);
                return "<SET varName=\"debugger_if_condition_eval\" evaluate=\"true\" export=\"false\"><![CDATA[ JSON.stringify(" + ifExpr + ") ]]></SET>";
            }
            return "";
        }());
        var sayTextValue = (function () {
            if (nextAction instanceof Say_1.Say) {
                var resp = utils_1.VarParser.parseVars(nextAction.ttsText);
                var text = resp[0];
                var varSets = resp[1].join("");
                return varSets + "<SET varName=\"debugger_say_text_eval\" evaluate=\"false\" export=\"false\"><![CDATA[ " + text.trim() + " ]]></SET>";
            }
            return "";
        })();
        return "\n            " + sayTextValue + " " + ifConditionValue + " " + localVarData + " " + jsonActionsData + "\n            <SET varName=\"debugger_action_id\" value=\"" + nextAction.id + "\" export=\"false\"/>\n            <WAIT nextActionId=\"TRIGGER_DEBUGGER\"/>\n        ";
    };
    return Debugger;
}(interfaces_1.CoreAction));
exports.Debugger = Debugger;
//# sourceMappingURL=Debugger.js.map