"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var Say_1 = require("./Say");
exports.DetectOnEvent = {
    OnLivePerson: "on_live_person",
    OnVoicemailEarly: "on_voicemail_early",
    OnVoicemail: "on_voicemail"
};
var Detect = (function (_super) {
    __extends(Detect, _super);
    function Detect(name) {
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "DETECT",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("detect"),
            },
            events: (_a = {},
                _a[exports.DetectOnEvent.OnLivePerson] = [],
                _a[exports.DetectOnEvent.OnVoicemailEarly] = [],
                _a[exports.DetectOnEvent.OnVoicemail] = [],
                _a)
        }) || this;
        _this.name = name;
        _this._triggerLiveInMS = 3000;
        _this.type = interfaces_1.Type.Detect;
        return _this;
        var _a;
    }
    Object.defineProperty(Detect.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Detect.prototype, "triggerLiveInMS", {
        get: function () {
            return this._triggerLiveInMS;
        },
        set: function (v) {
            this._triggerLiveInMS = Math.max(+v || 3000, 100);
        },
        enumerable: true,
        configurable: true
    });
    Detect.prototype.toCCML = function () {
        var playBrrr = "\n            <STOPAUDIO />\n            <PARALLEL scriptId=\"___detect_playBrrr___\" action=\"start\" />\n            <WAIT id=\"___detect_silence___\" silence=\"1\" />\n            <CONDITION>\n                <WAIT noise=\"1\" nextActionId=\"___detect_silence___\" />\n                <TIMER milliSeconds=\"1600\" waitForIdle=\"false\" nextActionId=\"" + "${next}" + "\" />\n            </CONDITION>\n            <PARALLEL scriptId=\"___detect_playBrrr___\" action=\"stop\" />\n        ";
        var liveDetection = "\n            <CONDITION>\n              <WAIT callProgress=\"AM\" nextActionId=\"___detect_endStateRouter___\">\n                <STOPAUDIO />\n              </WAIT>\n              <WAIT callState=\"CONNECT\" nextActionId=\"___detect_endStateRouter___\" />\n              <TIMER seconds=\"300\" nextActionId=\"___detect_endStateRouter___\" />\n            </CONDITION>\n        ";
        var vmDetection = "\n            <CONDITION>\n              <WAIT noise=\"500\" nextActionId=\"___detect_onVoicemailEarly___\">\n                <STOPAUDIO />\n              </WAIT>\n              <TIMER milliSeconds=\"2000\" nextActionId=\"" + "${next}" + "\"/>\n            </CONDITION>\n        ";
        if (this.events[exports.DetectOnEvent.OnLivePerson].length === 0) {
            this.events[exports.DetectOnEvent.OnLivePerson] = [new Say_1.Say("Error. The detect on live person event requires an action.", "onLivePersonError")];
        }
        if (this.events[exports.DetectOnEvent.OnVoicemail].length === 0) {
            this.events[exports.DetectOnEvent.OnVoicemail] = [new Say_1.Say("Error. The detect on voice mail event requires an action.", "onVoiceMailError")];
        }
        else if (this.events[exports.DetectOnEvent.OnVoicemailEarly].length === 0 && this.events[exports.DetectOnEvent.OnVoicemail][0].type === interfaces_1.Type.HangUp) {
            this.events[exports.DetectOnEvent.OnVoicemailEarly] = [this.events[exports.DetectOnEvent.OnVoicemail][0]];
            this.events[exports.DetectOnEvent.OnVoicemail] = [];
        }
        this.events[exports.DetectOnEvent.OnLivePerson].filter(function (e) { return e.type === interfaces_1.Type.Say || e.type === interfaces_1.Type.Play; }).forEach(function (e) { return e.injectCCML = liveDetection; });
        this.events[exports.DetectOnEvent.OnVoicemailEarly].filter(function (e) { return e.type === interfaces_1.Type.Say || e.type === interfaces_1.Type.Play; }).forEach(function (e) { return e.injectCCML = vmDetection; });
        this.events[exports.DetectOnEvent.OnVoicemail].filter(function (e) { return e.type === interfaces_1.Type.Say || e.type === interfaces_1.Type.Play; }).forEach(function (e) { return e.injectCCML = vmDetection; });
        var ccml = "\n            <DSP  varName=\"dspA\" detectTones=\"737, 738, 850, 870, 1000, 1005\"\n                  silenceDeadBand=\"600\"\n                  voiceDeadBand=\"200\"\n                  voiceThreshold=\"-45dB\"\n            />\n\n            <WAIT callState=\"CONNECT\" />\n\n            <CONDITION>\n                <WAIT callProgress=\"VOICE\" nextActionId=\"___detect_onLivePerson___\"/>\n                <WAIT callProgress=\"AM\" nextActionId=\"___detect_endStateRouter___\"/>\n                <WAIT callProgress=\"any\" nextActionId=\"___detect_endStateRouter___\" />\n                <TIMER milliSeconds=\"" + this.triggerLiveInMS + "\" waitForIdle=\"false\" nextActionId=\"___detect_onLivePerson___\" />\n            </CONDITION>\n\n            <BOOKMARK id=\"___detect_endStateRouter___\" />\n            <CONDITION>\n                <WAIT callProgress=\"AM\" nextActionId=\"___detect_onVoicemailEarly___\" />\n                <WAIT callProgress=\"VOICE\" nextActionId=\"___detect_done___\" />\n                <WAIT condition=\"true\" nextActionId=\"___detect_defaultError___\" />\n            </CONDITION>\n\n            <BOOKMARK id=\"___detect_defaultError___\"/>\n            <HANGUP />\n\n            <SUBSCRIPT id=\"___detect_playBrrr___\" inheritGlobalConditions=\"false\">\n                <TIMER milliSeconds=\"1000\" />\n                <PLAYTONE id=\"___detect_brrrTone___\" freq1=\"75\" freq2=\"10\" ampl1=\"-15\" ampl2=\"-15\" duration=\"2000\" />\n                <TIMER milliSeconds=\"3000\" nextActionId=\"___detect_brrrTone___\" />\n            </SUBSCRIPT>\n\n            <CONDITION global=\"true\">\n                <WAIT tone=\"any\" toneDuration=\"400\">\n                  <CONDITION>\n                    <WAIT condition=\"" + "${connectTime}" + " &gt; 2\" nextActionId=\"___detect_onVoicemailEarly___\">\n                      <STOPAUDIO />\n                    </WAIT>\n                    <WAIT condition=\"true\" nextActionId=\"" + "${next}" + ("\" />\n                  </CONDITION>\n                </WAIT>\n                <TIMER seconds=\"300\" nextActionId=\"___detect_defaultError___\" />\n            </CONDITION>\n\n            <BOOKMARK id=\"___detect_onLivePerson___\"/>\n                " + this.events[exports.DetectOnEvent.OnLivePerson].map(function (e) { return e.toCCML(); }).join("") + "\n            <WAIT nextActionId=\"___detect_done___\" />\n\n            <BOOKMARK id=\"___detect_onVoicemailEarly___\"/>\n                " + (this.events[exports.DetectOnEvent.OnVoicemailEarly].length === 0 ? playBrrr : this.events[exports.DetectOnEvent.OnVoicemailEarly].map(function (e) { return e.toCCML(); }).join("")) + "\n\n            <BOOKMARK id=\"___detect_onVoicemail___\"/>\n                " + this.events[exports.DetectOnEvent.OnVoicemail].map(function (e) { return e.toCCML(); }).join("") + "\n\n            <BOOKMARK id=\"___detect_done___\" />\n            <WAIT callState=\"CONNECT\" />\n            <DSP action=\"stop\" />\n        ");
        return ccml;
    };
    return Detect;
}(interfaces_1.CoreAction));
exports.Detect = Detect;
//# sourceMappingURL=Detect.js.map