"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
exports.DialOnEvent = {
    OnError: "on_error",
};
var Dial = (function (_super) {
    __extends(Dial, _super);
    function Dial(no, name) {
        if (no === void 0) { no = ""; }
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "DIAL",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("dial"),
                caller_id_no: "${apiNo}",
                detection: "none",
                inbound_api: "__CallFlows__",
                max_call_time: "86400",
                timeout: "50"
            },
            events: (_a = {},
                _a[exports.DialOnEvent.OnError] = [],
                _a)
        }) || this;
        _this.no = no;
        _this.name = name;
        _this._paramMap = {
            id: "id",
            caller_id_no: "from",
            detection: "detection",
            inbound_api: "campaignName",
            max_call_time: "maxCallTime",
            timeout: "maxAnswerTime",
        };
        _this._sessionData = "";
        _this._sessionDataType = "none";
        _this._disableRedialBlock = false;
        _this._overrideCallbackConfig = "";
        _this.type = interfaces_1.Type.Dial;
        return _this;
        var _a;
    }
    Object.defineProperty(Dial.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dial.prototype, "maxCallTime", {
        get: function () {
            return +this.getParam("max_call_time");
        },
        set: function (sec) {
            this.setParam("max_call_time", String(Math.min(86400 * 2, Math.max(60, sec))));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dial.prototype, "timeout", {
        get: function () {
            return +this.getParam("timeout");
        },
        set: function (sec) {
            this.setParam("timeout", String(Math.min(240, Math.max(20, sec))));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dial.prototype, "callerIdNo", {
        get: function () {
            return this.getParam("caller_id_no");
        },
        set: function (from) {
            this.setParam("caller_id_no", String(from));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dial.prototype, "detection", {
        get: function () {
            return this.getParam("detection");
        },
        set: function (type) {
            this.setParam("detection", String(type));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dial.prototype, "inboundAPI", {
        get: function () {
            var name = this.getParam("inbound_api");
            return name.substr(2, name.length - 2);
        },
        set: function (api) {
            this.setParam("inbound_api", "__" + String(api) + "__");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dial.prototype, "sessionData", {
        get: function () {
            return JSON.parse(this._sessionData);
        },
        set: function (data) {
            this._sessionDataType = typeof data;
            this._sessionData = JSON.stringify(data);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dial.prototype, "disableRedialBlock", {
        get: function () {
            return this._disableRedialBlock;
        },
        set: function (v) {
            this._disableRedialBlock = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dial.prototype, "overrideCallbackConfig", {
        get: function () {
            return this._overrideCallbackConfig;
        },
        set: function (v) {
            this._overrideCallbackConfig = String(v);
        },
        enumerable: true,
        configurable: true
    });
    Dial.prototype.toCCML = function () {
        var debugModeSet = "<SET varName=\"___debugMode___\" value=\"${___isDebugMode___}\"/>";
        var sessionDataSet = (function (type, data) {
            if (type === "none") {
                return "";
            }
            if (type !== "string") {
                return "<SET varName=\"___sessionData___\"><![CDATA[ " + data + " ]]></SET>";
            }
            try {
                var exp = utils_1.VarParser.parseExpression(JSON.parse(data));
                return "<SET varName=\"___sessionData___\" evaluate=\"true\"><![CDATA[ JSON.stringify( " + exp + " ) ]]></SET>";
            }
            catch (err) {
                return "<!-- SessionData Error: " + err.message + " -->";
            }
        }(this._sessionDataType, this._sessionData));
        var noVars = utils_1.VarParser.parseVars(this.no);
        this.no = noVars[0];
        var callerIdNoVars = utils_1.VarParser.parseVars(this.callerIdNo, noVars[1].length);
        this.callerIdNo = callerIdNoVars[0];
        var overrideCallbackConfigVars = (function (occ) {
            if (occ === "") {
                return ["", []];
            }
            return utils_1.VarParser.parseVars(occ, noVars[1].length + callerIdNoVars[1].length);
        }(this._overrideCallbackConfig));
        var overrideCallbackConfigSet = overrideCallbackConfigVars[0] ?
            "<SET varName=\"___overrideCallbackConfig___\" export=\"false\" value=\"" + this.escapeXml(overrideCallbackConfigVars[0]) + "\"/>" : "";
        var ccml = noVars[1].concat(callerIdNoVars[1], overrideCallbackConfigVars[1]).join("");
        var dialOriginVars = "<SET varName=\"___dialOrigin_no___\" export=\"false\" value=\"" + this.escapeXml(noVars[0]) + "\"/>";
        ccml += this._disableRedialBlock ? "" : "\n            <SET varName=\"___dialOrigin_temp_no___\" export=\"false\" value=\"" + this.escapeXml(noVars[0]) + "\"/>\n            <CONDITION>\n                <WAIT condition=\"${phoneRecordData.___dialOrigin_no___} == ${___dialOrigin_temp_no___} || ${___dialOrigin_no___} == ${___dialOrigin_temp_no___}\">\n                    <SAY>Error. A possible dial action recursive loop has been detected. Set disable redial block on the dial action to remove this check. Ending the call for your protection.</SAY>\n                    <HANGUP/>\n                </WAIT>\n                <WAIT condition=\"true\" nextActionId=\"${next}\"/>\n            </CONDITION>\n        ";
        var dialSendSets = [
            this.escapeXml(this.no), dialOriginVars, sessionDataSet, debugModeSet, overrideCallbackConfigSet,
        ].join("");
        if (this.events[exports.DialOnEvent.OnError].length > 0) {
            var id = interfaces_1.CoreAction.genId();
            if (sessionDataSet === "") {
                return ccml + "\n                    <DIAL" + _super.prototype.toCCML.call(this, this._paramMap) + " maxIdleTime=\"21600\" errorActionId=\"" + id + "_onError\">" + dialSendSets + "</DIAL>\n                    <WAIT condition=\"true\" nextActionId=\"" + id + "_onSuccess\"/>\n                    <BOOKMARK id=\"" + id + "_onError\"/>\n                        " + this.events[exports.DialOnEvent.OnError].map(function (e) { return e.toCCML(); }).join("") + "\n                    <BOOKMARK id=\"" + id + "_onSuccess\"/>\n                ";
            }
            else {
                return ccml + "\n                    <SET varName=\"___local_sessionData___\" value=\"${___sessionData___}\"/>\n                    <DIAL" + _super.prototype.toCCML.call(this, this._paramMap) + " maxIdleTime=\"21600\" errorActionId=\"" + id + "_onError\">" + dialSendSets + "</DIAL>\n                    <WAIT condition=\"true\" nextActionId=\"" + id + "_onSuccess\"/>\n                    <BOOKMARK id=\"" + id + "_onError\"/>\n                        <SET varName=\"___sessionData___\" value=\"${___local_sessionData___}\"/>\n                        <SET varName=\"___local_sessionData___\" value=\"${NULL}\"/>\n                        " + this.events[exports.DialOnEvent.OnError].map(function (e) { return e.toCCML(); }).join("") + "\n                        <WAIT condition=\"true\" nextActionId=\"" + id + "_onSuccessSkipSessionData\"/>\n                    <BOOKMARK id=\"" + id + "_onSuccess\"/>\n                    <SET varName=\"___sessionData___\" value=\"${___local_sessionData___}\"/>\n                    <SET varName=\"___local_sessionData___\" value=\"${NULL}\"/>\n                    <BOOKMARK id=\"" + id + "_onSuccessSkipSessionData\"/>\n                ";
            }
        }
        if (sessionDataSet === "") {
            return ccml + "\n                <DIAL" + _super.prototype.toCCML.call(this, this._paramMap) + " maxIdleTime=\"21600\">" + dialSendSets + "</DIAL>\n            ";
        }
        else {
            return ccml + "\n                <SET varName=\"___local_sessionData___\" value=\"${___sessionData___}\"/>\n                <DIAL" + _super.prototype.toCCML.call(this, this._paramMap) + " maxIdleTime=\"21600\">" + dialSendSets + "</DIAL>\n                <SET varName=\"___sessionData___\" value=\"${___local_sessionData___}\"/>\n                <SET varName=\"___local_sessionData___\" value=\"${NULL}\"/>\n            ";
        }
    };
    return Dial;
}(interfaces_1.CoreAction));
exports.Dial = Dial;
//# sourceMappingURL=Dial.js.map