"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
var Goto_1 = require("./Goto");
var If_1 = require("./If");
var Label_1 = require("./Label");
var Var_1 = require("./Var");
exports.ForEachEvent = {
    OnNext: "on_next",
};
var ForEach = (function (_super) {
    __extends(ForEach, _super);
    function ForEach(iterator, next, valueVar, indexVar, keyVar, name) {
        if (valueVar === void 0) { valueVar = "$val"; }
        if (indexVar === void 0) { indexVar = "$index"; }
        if (keyVar === void 0) { keyVar = "$key"; }
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "FOREACH",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("foreach"),
            },
        }) || this;
        _this.iterator = iterator;
        _this.next = next;
        _this.valueVar = valueVar;
        _this.indexVar = indexVar;
        _this.keyVar = keyVar;
        _this.name = name;
        _this.type = interfaces_1.Type.ForEach;
        return _this;
    }
    Object.defineProperty(ForEach.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    ForEach.prototype.toCCML = function () {
        var fid = interfaces_1.CoreAction.genId();
        var secretIndex = "$index" + fid;
        var secretObjKeys = "$keys" + fid;
        var secretIteratorLen = "$len" + fid;
        var _a = utils_1.VarParser.parseVars(this.iterator), parseItVar = _a[0], parseItSets = _a[1];
        var nextActions = [
            new Var_1.Var(this.indexVar, secretIndex),
            new Var_1.Var(this.keyVar, secretObjKeys + "[" + secretIndex + "]"),
            new Var_1.Var(this.valueVar, parseItVar + "[" + this.keyVar + "]")
        ].concat(this.next);
        var ccml = parseItSets.concat([
            new Var_1.Var(secretIndex, "0").toCCML(),
            new Var_1.Var(secretObjKeys, "(function (it) { return Object.prototype.toString.call(it) === '[object Array]' ? Array.apply(null, Array(it.length)).map(function (v,i) { return i }) : Object.keys(it); }( " + parseItVar + " ))").toCCML(),
            new Var_1.Var(secretIteratorLen, "(function (it) { return Object.prototype.toString.call(it) === '[object Array]' ? it.length : Object.keys(it).length; }( " + parseItVar + " ))").toCCML(),
            new Label_1.Label(fid + "_continue_loop").toCCML(),
            (function () {
                var iff = new If_1.If(secretIteratorLen + " > " + secretIndex, nextActions);
                iff.setEvent(If_1.IfEvent.OnElse, [new Goto_1.Goto(fid + "_break_loop")]);
                return iff.toCCML();
            })(),
            new Var_1.Var(secretIndex, secretIndex + " + 1").toCCML(),
            new Goto_1.Goto(fid + "_continue_loop").toCCML(),
            new Label_1.Label(fid + "_break_loop").toCCML(),
        ]);
        return ccml.join("");
    };
    return ForEach;
}(interfaces_1.CoreAction));
exports.ForEach = ForEach;
//# sourceMappingURL=ForEach.js.map