"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
var GoogleAnalytics = (function (_super) {
    __extends(GoogleAnalytics, _super);
    function GoogleAnalytics(callbackResponse, params, name) {
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "GOOGLEANALYTICS",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("google_analytics"),
                varName: "___google-analytics_var___",
                url: "https://ssl.google-analytics.com/collect",
                method: "post",
                timeout: "30",
                async: "true",
            }
        }) || this;
        _this.name = name;
        _this._paramMap = {
            id: "id",
            url: "url",
            method: "method",
            timeout: "timeout",
            async: "async",
        };
        _this._gaParams = {
            "tid": "${___config___.google_analytics.tracking_id}",
            "an": "${___config___.google_analytics.source}",
            "v": "1",
            "aip": "1",
            "ds": "phone",
            "geoid": "US",
            "av": "1.0",
        };
        _this.type = interfaces_1.Type.GoogleAnalytics;
        _this._gaParams.dt = name || undefined;
        if (callbackResponse !== undefined) {
            _this._gaParams.aid = callbackResponse.app_id;
            _this._gaParams.uid = utils_1.MD5.hash(callbackResponse.caller_no);
            _this._gaParams.cid = utils_1.MD5.hash(callbackResponse.call_id + "-" + callbackResponse.app_id);
            _this._gaParams.cd = callbackResponse.api_no + "/" + name;
            _this._gaParams.dh = callbackResponse.api_no;
            _this._gaParams.dp = callbackResponse.api_no + "/" + name;
        }
        if (params !== undefined) {
            for (var k in params) {
                if (params.hasOwnProperty(k)) {
                    _this._gaParams[k] = String(params[k]);
                }
            }
        }
        return _this;
    }
    Object.defineProperty(GoogleAnalytics.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    GoogleAnalytics.prototype.setGAEvent = function (action, label, category, value) {
        if (label === void 0) { label = ""; }
        if (category === void 0) { category = "action"; }
        if (value === void 0) { value = 1; }
        this._gaParams.t = "event";
        this._gaParams.ec = "action";
        this._gaParams.ea = action;
        this._gaParams.el = label || undefined;
        this._gaParams.ec = category;
        this._gaParams.ev = String(value);
    };
    GoogleAnalytics.prototype.getGAEvent = function () {
        return {
            action: this._gaParams.ea,
            label: this._gaParams.el,
            category: this._gaParams.ec,
            value: +this._gaParams.ev
        };
    };
    GoogleAnalytics.prototype.toCCML = function () {
        var ccml = "<REQUEST " + _super.prototype.toCCML.call(this, this._paramMap) + ">";
        for (var k in this._gaParams) {
            if (this._gaParams.hasOwnProperty(k)) {
                ccml += "<SET varName=\"" + k + "\" value=" + JSON.stringify(this._gaParams[k]) + " export=\"false\"/>";
            }
        }
        ccml += "</REQUEST>";
        return ccml.replace(/[ \n]+/g, " ").trim();
    };
    return GoogleAnalytics;
}(interfaces_1.CoreAction));
exports.GoogleAnalytics = GoogleAnalytics;
//# sourceMappingURL=GoogleAnalytics.js.map