"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
exports.IfEvent = {
    OnThen: "on_then",
    OnElse: "on_else",
};
var If = (function (_super) {
    __extends(If, _super);
    function If(_condition, then, name) {
        if (_condition === void 0) { _condition = "true"; }
        if (then === void 0) { then = []; }
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "IF",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("if"),
            },
            events: (_a = {},
                _a[exports.IfEvent.OnThen] = then,
                _a[exports.IfEvent.OnElse] = [],
                _a)
        }) || this;
        _this._condition = _condition;
        _this.name = name;
        _this._paramMap = {
            id: "id"
        };
        _this.type = interfaces_1.Type.If;
        return _this;
        var _a;
    }
    Object.defineProperty(If.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(If.prototype, "condition", {
        get: function () {
            return this._condition;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(If.prototype, "then", {
        get: function () {
            return this.getEvent(exports.IfEvent.OnThen);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(If.prototype, "orElse", {
        get: function () {
            return this.getEvent(exports.IfEvent.OnElse);
        },
        enumerable: true,
        configurable: true
    });
    If.prototype.toCCML = function () {
        this._condition = utils_1.VarParser.parseExpression(this._condition);
        var id = interfaces_1.CoreAction.genId();
        var paramStr = _super.prototype.toCCML.call(this, this._paramMap);
        var ccml = "\n            <CONDITION" + paramStr + ">\n                <WAIT nextActionId=\"" + id + "_ifThen\"><![CDATA[" + this._condition + "]]></WAIT>\n                <WAIT condition=\"true\" nextActionId=\"" + id + "_orElse\"/>\n            </CONDITION>\n            <BOOKMARK id=\"" + id + "_ifThen\"/>\n                " + this.getEvent(exports.IfEvent.OnThen).map(function (a) { return a.toCCML(); }).join("") + "\n                <WAIT condition=\"true\" nextActionId=\"" + id + "_endIf\"/>\n            <BOOKMARK id=\"" + id + "_orElse\"/>\n                " + this.getEvent(exports.IfEvent.OnElse).map(function (a) { return a.toCCML(); }).join("") + "\n            <BOOKMARK id=\"" + id + "_endIf\"/>\n        ";
        return ccml;
    };
    return If;
}(interfaces_1.CoreAction));
exports.If = If;
//# sourceMappingURL=If.js.map