"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var Record = (function (_super) {
    __extends(Record, _super);
    function Record(action, group, name) {
        if (action === void 0) { action = "START"; }
        if (group === void 0) { group = "$PN+{ani}"; }
        if (name === void 0) { name = "rec_" + interfaces_1.CoreAction.genId(); }
        var _this = _super.call(this, {
            type: "RECORDCALL",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("rec"),
                group: group,
                action: action === "RESUME" ? "unpause" : action.toLowerCase()
            }
        }) || this;
        _this.name = name;
        _this._paramMap = {
            id: "id",
            group: "traceName",
            action: "control"
        };
        _this.type = interfaces_1.Type.Record;
        return _this;
    }
    Object.defineProperty(Record.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Record.prototype, "group", {
        get: function () {
            return this.getParam("group");
        },
        set: function (group) {
            this.setParam("group", group);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Record.prototype, "action", {
        get: function () {
            return this.getParam("action") === "unpause" ? "RESUME" : this.getParam("action").toUpperCase();
        },
        set: function (action) {
            this.setParam("action", action === "RESUME" ? "unpause" : action.toLowerCase());
        },
        enumerable: true,
        configurable: true
    });
    Record.prototype.toCCML = function () {
        var paramStr = _super.prototype.toCCML.call(this, this._paramMap);
        if (this.getParam("action") !== "START") {
            return "<RECORDCALL" + paramStr + "/>";
        }
        var ccml = [];
        ccml.push("<RECORDCALL" + paramStr + " varName=\"___recordId___\"/>");
        ccml.push("<SET varName=\"recordings\" value=\"${recordings}" + this.name + "=${___recordId___}&amp;\" export=\"true\"/>");
        return ccml.join("");
    };
    return Record;
}(interfaces_1.CoreAction));
exports.Record = Record;
//# sourceMappingURL=Record.js.map