"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
var Redirect = (function (_super) {
    __extends(Redirect, _super);
    function Redirect(_callbackUrl, name) {
        if (_callbackUrl === void 0) { _callbackUrl = ""; }
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "REDIRECT",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("redirect"),
            }
        }) || this;
        _this._callbackUrl = _callbackUrl;
        _this.name = name;
        _this.type = interfaces_1.Type.Redirect;
        return _this;
    }
    Object.defineProperty(Redirect.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Redirect.prototype, "url", {
        get: function () {
            return this._callbackUrl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Redirect.prototype, "method", {
        get: function () {
            return this._callbackMethod;
        },
        set: function (val) {
            this._callbackMethod = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Redirect.prototype, "headers", {
        get: function () {
            return this._callbackHeaders;
        },
        set: function (val) {
            this._callbackHeaders = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Redirect.prototype, "contentType", {
        get: function () {
            return this._callbackContentType;
        },
        set: function (val) {
            this._callbackContentType = val;
        },
        enumerable: true,
        configurable: true
    });
    Redirect.prototype.toCCML = function () {
        var ccml = [];
        if (this._callbackUrl) {
            var _a = utils_1.VarParser.parseVars(this._callbackUrl), url = _a[0], varSetup = _a[1];
            ccml.push.apply(ccml, varSetup);
            ccml.push("\n                <SET varName=\"___redirectTempUrl___\" value=" + JSON.stringify(url) + " export=\"false\"/>\n                <SET varName=\"___dynamicCallbackUrl___\" evaluate=\"true\" export=\"true\"><![CDATA[\n                    (function (orig, rel) {\n                        if (rel.indexOf('://') !== -1) return rel;\n                        relParts = rel.split(\"../\");\n                        origParts = orig.split(\"/\").slice(0, -relParts.length);\n                        return [].concat(origParts, relParts.pop()).join(\"/\");\n                    }(${___dynamicCallbackUrl___}, ${___redirectTempUrl___}))\n                ]]></SET>\n            ");
        }
        if (this._callbackMethod) {
            var _b = utils_1.VarParser.parseVars(this._callbackMethod), method = _b[0], varSetup = _b[1];
            ccml.push.apply(ccml, varSetup);
            ccml.push("<SET varName=\"___dynamicCallbackMethod___\" value=" + JSON.stringify(method) + " export=\"true\"/>");
        }
        if (this._callbackHeaders) {
            ccml.push("<SET varName=\"___dynamicCallbackHeaders___\" value=" + JSON.stringify(JSON.stringify(this._callbackHeaders)) + " export=\"true\"/>");
        }
        if (this._callbackContentType) {
            var _c = utils_1.VarParser.parseVars(this._callbackContentType), contentType = _c[0], varSetup = _c[1];
            ccml.push.apply(ccml, varSetup);
            ccml.push("<SET varName=\"___dynamicCallbackContentType___\" value=" + JSON.stringify(contentType) + " export=\"true\"/>");
        }
        return ccml.join("");
    };
    return Redirect;
}(interfaces_1.CoreAction));
exports.Redirect = Redirect;
//# sourceMappingURL=Redirect.js.map