"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
var SMS = (function (_super) {
    __extends(SMS, _super);
    function SMS(message, name) {
        if (message === void 0) { message = "message is empty"; }
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "SMS",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("sms"),
                no: "${callerNo}",
                caller_id_no: "${apiNo}"
            }
        }) || this;
        _this.message = message;
        _this.name = name;
        _this._paramMap = {
            id: "id",
            no: "to",
            caller_id_no: "from"
        };
        _this.type = interfaces_1.Type.SMS;
        return _this;
    }
    Object.defineProperty(SMS.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SMS.prototype, "no", {
        get: function () {
            return this.getParam("no");
        },
        set: function (no) {
            this.setParam("no", no);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SMS.prototype, "callerIdNo", {
        get: function () {
            return this.getParam("caller_id_no");
        },
        set: function (no) {
            this.setParam("caller_id_no", no);
        },
        enumerable: true,
        configurable: true
    });
    SMS.prototype.toCCML = function () {
        var ccml = "";
        var noVars = utils_1.VarParser.parseVars(this.no);
        this.no = noVars[0];
        ccml += noVars[1].join("");
        var callerIdNoVars = utils_1.VarParser.parseVars(this.callerIdNo, noVars[1].length);
        this.callerIdNo = callerIdNoVars[0];
        ccml += callerIdNoVars[1].join("");
        var messageVars = utils_1.VarParser.parseVars(this.message, noVars[1].length + callerIdNoVars[1].length);
        this.message = messageVars[0];
        ccml += messageVars[1].join("");
        var paramStr = _super.prototype.toCCML.call(this, this._paramMap);
        return ccml + "<TEXTMESSAGE" + paramStr + "><![CDATA[" + this.message + "]]></TEXTMESSAGE>";
    };
    return SMS;
}(interfaces_1.CoreAction));
exports.SMS = SMS;
//# sourceMappingURL=SMS.js.map