"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
var Say = (function (_super) {
    __extends(Say, _super);
    function Say(text, name) {
        if (text === void 0) { text = "This say action text is missing."; }
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "SAY",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("say"),
                stop_on_key: "false",
                voice: "default",
                language: "default",
                gender: "default",
                repeatMax: "0"
            },
        }) || this;
        _this.text = text;
        _this.name = name;
        _this._paramMap = {
            id: "id",
            voice: "voice",
            language: "language",
            gender: "gender",
            stop_on_key: "stopOnKeyPressed",
            repeatMax: "repeatMax"
        };
        _this._repeat = 1;
        _this._parseVars = true;
        _this._injectCCML = "";
        _this.type = interfaces_1.Type.Say;
        return _this;
    }
    Object.defineProperty(Say.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Say.prototype, "ttsText", {
        get: function () {
            return this.text;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Say.prototype, "repeat", {
        get: function () {
            return this._repeat;
        },
        set: function (num) {
            this._repeat = Math.min(Math.max(1, +num), 10);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Say.prototype, "parseVars", {
        get: function () {
            return this._parseVars;
        },
        set: function (val) {
            this._parseVars = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Say.prototype, "stopOnKey", {
        get: function () {
            return this.getParam("stop_on_key") === "true";
        },
        set: function (val) {
            this.setParam("stop_on_key", val ? "true" : "false");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Say.prototype, "voice", {
        get: function () {
            return this.getParam("voice");
        },
        set: function (val) {
            this.setParam("voice", val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Say.prototype, "language", {
        get: function () {
            return this.getParam("language");
        },
        set: function (val) {
            this.setParam("language", val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Say.prototype, "gender", {
        get: function () {
            return this.getParam("gender");
        },
        set: function (val) {
            this.setParam("gender", val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Say.prototype, "injectCCML", {
        get: function () {
            return this._injectCCML;
        },
        set: function (c) {
            this._injectCCML = c || "";
        },
        enumerable: true,
        configurable: true
    });
    Say.prototype.toCCML = function (filter) {
        var ccml = [];
        if (filter !== "says") {
            if (this._parseVars) {
                var resp = utils_1.VarParser.parseVars(this.text);
                this.text = resp[0];
                ccml = ccml.concat(resp[1]);
            }
        }
        if (filter !== "sets") {
            var txt = "";
            for (var i = 0; i < this.repeat; i++) {
                txt += this.text + " ";
            }
            ccml.push("<SAY" + _super.prototype.toCCML.call(this, this._paramMap) + "><![CDATA[ " + txt.trim() + " ]]>" + this.injectCCML + "</SAY>");
        }
        return ccml.join("");
    };
    return Say;
}(interfaces_1.CoreAction));
exports.Say = Say;
//# sourceMappingURL=Say.js.map