"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
var Transfer = (function (_super) {
    __extends(Transfer, _super);
    function Transfer(no, name) {
        if (no === void 0) { no = ""; }
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "TRANSFER",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("transfer"),
                event: "start",
                caller_id_no: "${callerNo}",
                redials: "0",
                async: false
            }
        }) || this;
        _this.no = no;
        _this.name = name;
        _this._paramMap = {
            id: "id",
            event: "control",
            caller_id_no: "from",
            redials: "redials",
            async: "async"
        };
        _this.type = interfaces_1.Type.Transfer;
        return _this;
    }
    Object.defineProperty(Transfer.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Transfer.prototype, "event", {
        get: function () {
            return this.getParam("event");
        },
        set: function (e) {
            this.setParam("event", String(e));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Transfer.prototype, "callerIdNo", {
        get: function () {
            return this.getParam("caller_id_no");
        },
        set: function (no) {
            this.setParam("caller_id_no", String(no));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Transfer.prototype, "async", {
        get: function () {
            return this.getParam("async") === "true";
        },
        set: function (val) {
            this.setParam("async", val ? "true" : "false");
        },
        enumerable: true,
        configurable: true
    });
    Transfer.prototype.toCCML = function () {
        var ccml = "";
        var noVars = utils_1.VarParser.parseVars(this.no);
        this.no = noVars[0];
        ccml += noVars[1].join("");
        var callerIdNoVars = utils_1.VarParser.parseVars(this.callerIdNo, noVars[1].length);
        this.callerIdNo = callerIdNoVars[0];
        ccml += callerIdNoVars[1].join("");
        return ccml + "<CALLTRANSFER" + _super.prototype.toCCML.call(this, this._paramMap) + ">" + this.escapeXml(this.no) + "</CALLTRANSFER>";
    };
    return Transfer;
}(interfaces_1.CoreAction));
exports.Transfer = Transfer;
//# sourceMappingURL=Transfer.js.map