"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
var Var = (function (_super) {
    __extends(Var, _super);
    function Var(_assignmentVar, _expression, name) {
        if (name === void 0) { name = _assignmentVar; }
        var _this = _super.call(this, {
            type: "VAR",
            name: name,
            comments: _assignmentVar + " = " + _expression,
            params: {
                id: interfaces_1.CoreAction.genId("var"),
                assignmentVar: _assignmentVar,
                expression: _expression,
            },
        }) || this;
        _this.name = name;
        _this.type = interfaces_1.Type.Var;
        return _this;
    }
    Object.defineProperty(Var.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Var.prototype, "assignmentVar", {
        get: function () {
            return this.getParam("assignmentVar");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Var.prototype, "expression", {
        get: function () {
            return this.getParam("expression");
        },
        enumerable: true,
        configurable: true
    });
    Var.prototype.toCCML = function () {
        var av = utils_1.VarParser.parseAssignmentVar(this.assignmentVar);
        if (av === undefined) {
            return "";
        }
        var exp = utils_1.VarParser.parseExpression(this.expression);
        if (!av[1]) {
            return "\n                <SET varName=\"" + av[0] + "\" evaluate=\"true\" export=\"false\"><![CDATA[ JSON.stringify(" + exp + ") ]]></SET>\n            ";
        }
        else {
            return "\n                <SET varName=\"" + av[2] + "\" evaluate=\"true\" export=\"false\"><![CDATA[ JSON.stringify(" + exp + ") ]]></SET>\n                <SET varName=\"" + av[0] + "\" evaluate=\"true\" export=\"false\"><![CDATA[\n                    (function () {\n                        try {\n                            var data = JSON.parse(${" + av[0] + "});\n                            data" + av[1] + " = JSON.parse(${" + av[2] + "});\n                            return JSON.stringify(data);\n                        } catch (e) {\n                            return ${" + av[0] + "};\n                        }\n                    }())\n                ]]></SET>\n            ";
        }
    };
    return Var;
}(interfaces_1.CoreAction));
exports.Var = Var;
//# sourceMappingURL=Var.js.map