"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var utils_1 = require("../utils");
exports.WebhookOnEvent = {
    OnError: "on_error",
};
var Webhook = (function (_super) {
    __extends(Webhook, _super);
    function Webhook(eventName, name) {
        if (eventName === void 0) { eventName = "webhook"; }
        if (name === void 0) { name = "action"; }
        var _this = _super.call(this, {
            type: "WEBHOOK",
            name: name,
            comments: "",
            params: {
                id: interfaces_1.CoreAction.genId("webhook"),
                varName: "___webhookDataResponse___",
                url: "${___internalCallbackUrl___}",
                url2: "${___internalCallbackUrl2___}",
                url3: "${___internalCallbackUrl3___}",
                method: "post",
                failureRetryMax: "0",
                failureRetryDelay: "100",
                timeout: "30",
                async: "true",
                includeExportedVars: "true",
            },
            events: (_a = {},
                _a[exports.WebhookOnEvent.OnError] = [],
                _a)
        }) || this;
        _this.eventName = eventName;
        _this.name = name;
        _this._paramMap = {
            id: "id",
            url: "url",
            url2: "url2",
            url3: "url3",
            method: "method",
            failureRetryMax: "failureRetryMax",
            failureRetryDelay: "failureRetryDelay",
            timeout: "timeout",
            async: "async",
            varName: "varName",
            includeExportedVars: "includeExportedVars",
        };
        _this._webhookData = "{}";
        _this._webhookDataType = "object";
        _this._awaitResponse = false;
        _this.type = interfaces_1.Type.Webhook;
        return _this;
        var _a;
    }
    Object.defineProperty(Webhook.prototype, "id", {
        get: function () {
            return this.getParam("id");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Webhook.prototype, "url", {
        get: function () {
            return this._url;
        },
        set: function (url) {
            this._url = String(url);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Webhook.prototype, "method", {
        get: function () {
            return this._method;
        },
        set: function (method) {
            this._method = String(method);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Webhook.prototype, "headers", {
        get: function () {
            return this._headers;
        },
        set: function (headers) {
            this._headers = headers;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Webhook.prototype, "contentType", {
        get: function () {
            return this._contentType;
        },
        set: function (contentType) {
            this._contentType = String(contentType);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Webhook.prototype, "webhookData", {
        get: function () {
            return JSON.parse(this._webhookData);
        },
        set: function (data) {
            this._webhookDataType = typeof data;
            this._webhookData = JSON.stringify(data);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Webhook.prototype, "awaitResponse", {
        get: function () {
            return this._awaitResponse;
        },
        set: function (v) {
            this._awaitResponse = v;
        },
        enumerable: true,
        configurable: true
    });
    Webhook.prototype.toCCML = function () {
        var id = interfaces_1.CoreAction.genId();
        var dataSet = (function (type, data) {
            if (type !== "string") {
                return "<SET varName=\"webhook_data\" export=\"false\"><![CDATA[" + data + "]]></SET>";
            }
            try {
                var exp = utils_1.VarParser.parseExpression(JSON.parse(data));
                return "<SET varName=\"webhook_data\" evaluate=\"true\" export=\"false\"><![CDATA[ JSON.stringify( " + exp + " ) ]]></SET>";
            }
            catch (err) {
                return "<SET varName=\"webhook_data\" export=\"false\"><![CDATA[" + data + "]]></SET>";
            }
        }(this._webhookDataType, this._webhookData));
        var eventHandler = (function (isAwait, onError) {
            if (isAwait) {
                return "\n                    <WAIT nextActionId=\"" + id + "_onSuccess\"/>\n                    <BOOKMARK id=\"" + id + "_onError\"/>\n                        <SET varName=\"___webhookData___\" value=\"${NULL}\" export=\"false\"/>\n                        " + onError.map(function (e) { return e.toCCML(); }).join("") + "\n                        <WAIT nextActionId=\"" + id + "_onSkipSuccess\"/>\n                    <BOOKMARK id=\"" + id + "_onSuccess\"/>\n                    <SET varName=\"___webhookData___\" value=\"${___webhookDataResponse___.data}\" export=\"false\"/>\n                    <BOOKMARK id=\"" + id + "_onSkipSuccess\"/>\n                ";
            }
            else {
                return "\n                    <WAIT nextActionId=\"" + id + "_onSuccess\"/>\n                    <BOOKMARK id=\"" + id + "_onError\"/>\n                        " + onError.map(function (e) { return e.toCCML(); }).join("") + "\n                    <BOOKMARK id=\"" + id + "_onSuccess\"/>\n                ";
            }
        }(this._awaitResponse, this.events[exports.WebhookOnEvent.OnError]));
        if (this._awaitResponse || this.events[exports.WebhookOnEvent.OnError].length > 0) {
            this.setParam("async", "false");
        }
        return "\n            <REQUEST " + _super.prototype.toCCML.call(this, this._paramMap) + " errorActionId=\"" + id + "_onError\">\n                " + dataSet + "\n                <SET varName=\"___is_webhook_action___\" value=\"true\" export=\"false\"/>\n                <SET varName=\"___is_webhook_await___\" value=\"" + this._awaitResponse.toString() + "\" export=\"false\"/>\n                <SET varName=\"webhook_event_name\" value=\"" + this.eventName + "\" export=\"false\"/>\n                <SET varName=\"config_callback_url\" value=\"" + (this._url || "${___config___.callback.url}") + "\"/>\n                <SET varName=\"config_callback_method\" value=\"" + (this._method || "${___config___.callback.method}") + "\"/>\n                <SET varName=\"config_callback_headers\"><![CDATA[ " + (this.headers ? JSON.stringify(this.headers) : "${___config___.callback.headers}") + " ]]></SET>\n                <SET varName=\"config_callback_content_type\" value=\"" + (this._contentType || "${___config___.callback.content_type}") + "\"/>\n                <SET varName=\"callTime\" value=\"${callTimeMS}\"/>\n                <SET varName=\"last_queue_poll_connect_call\" value=\"${___lastQueuePollConnectCall___}\"/>\n                <SET varName=\"session_data\" value=\"${___sessionData___}\"/>\n            </REQUEST>\n            " + eventHandler + "\n        ";
    };
    return Webhook;
}(interfaces_1.CoreAction));
exports.Webhook = Webhook;
//# sourceMappingURL=Webhook.js.map