"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Type;
(function (Type) {
    Type[Type["CCML"] = 0] = "CCML";
    Type[Type["Collect"] = 1] = "Collect";
    Type[Type["Conference"] = 2] = "Conference";
    Type[Type["Debugger"] = 3] = "Debugger";
    Type[Type["Detect"] = 4] = "Detect";
    Type[Type["Dial"] = 5] = "Dial";
    Type[Type["ForEach"] = 6] = "ForEach";
    Type[Type["Function"] = 7] = "Function";
    Type[Type["GoogleAnalytics"] = 8] = "GoogleAnalytics";
    Type[Type["Goto"] = 9] = "Goto";
    Type[Type["HangUp"] = 10] = "HangUp";
    Type[Type["If"] = 11] = "If";
    Type[Type["Label"] = 12] = "Label";
    Type[Type["Pause"] = 13] = "Pause";
    Type[Type["Play"] = 14] = "Play";
    Type[Type["Queue"] = 15] = "Queue";
    Type[Type["Record"] = 16] = "Record";
    Type[Type["RecordMessage"] = 17] = "RecordMessage";
    Type[Type["Redirect"] = 18] = "Redirect";
    Type[Type["Reject"] = 19] = "Reject";
    Type[Type["Say"] = 20] = "Say";
    Type[Type["SessionData"] = 21] = "SessionData";
    Type[Type["SMS"] = 22] = "SMS";
    Type[Type["Stop"] = 23] = "Stop";
    Type[Type["Transfer"] = 24] = "Transfer";
    Type[Type["Var"] = 25] = "Var";
    Type[Type["Webhook"] = 26] = "Webhook";
})(Type = exports.Type || (exports.Type = {}));
var idCounter = 10000;
var CoreAction = (function () {
    function CoreAction(data) {
        this.data = data;
        this.params = this.data.params || {};
        this.events = this.data.events || {};
        this.name = this.data.name || "";
        this.comments = this.data.comments || "";
    }
    CoreAction.genId = function (prefix) {
        if (prefix === void 0) { prefix = ""; }
        if (prefix === "") {
            prefix += "_";
        }
        idCounter++;
        return prefix + idCounter.toString(36);
    };
    CoreAction.prototype.setParam = function (name, val) {
        this.params[name] = val;
    };
    CoreAction.prototype.getParam = function (name) {
        return this.params[name];
    };
    CoreAction.prototype.setEvent = function (name, val) {
        this.events[name] = val;
    };
    CoreAction.prototype.getEvent = function (name) {
        return this.events[name] || [];
    };
    CoreAction.prototype.toCCML = function (paramMap) {
        var _this = this;
        return Object.keys(paramMap)
            .filter(function (k) { return _this.params[k] !== null && _this.params[k] !== undefined && _this.params[k] !== ""; })
            .reduce(function (p, k) { return p + " " + paramMap[k] + "=" + JSON.stringify(String(_this.params[k])); }, "");
    };
    CoreAction.prototype.escapeXml = function (unsafe) {
        return unsafe.replace(/[<>&'"]/g, function (c) {
            switch (c) {
                case "<": return "&lt;";
                case ">": return "&gt;";
                case "&": return "&amp;";
                case "\'": return "&apos;";
                case "\"": return "&quot;";
                default: return c;
            }
        });
    };
    CoreAction.prototype.escapeDoubleQuotes = function (unsafe) {
        return unsafe.replace(/["]/g, "\\\"");
    };
    return CoreAction;
}());
exports.CoreAction = CoreAction;
//# sourceMappingURL=interfaces.js.map