"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var OBJ_MAP = {
    sessionData: "${___sessionData___}",
    webhookData: "${___webhookData___}",
    functionData: "${___actionFunctionData___}",
    config: "${___config___}",
    lastQueuePollConnectCall: "${___lastQueuePollConnectCall___}",
};
var OBJ_MAP_KEYS = Object.keys(OBJ_MAP);
var VAR_MAP = {
    isDebugMode: "${___isDebugMode___}",
    isInitCall: "${___isInit___}",
    now: "${timestamp}",
    callTime: "${callTimeMS}",
    direction: "${callType}",
    startTime: "${___startTime___}",
    callerNo: "${caller_no}",
    "...callerNo": "$PN{caller_no}",
    callerNoRegion: "${caller_no_region}",
    callerNoCountry: "${caller_no_country}",
    callerNoTimeZone: "${caller_no_timezone}",
    apiNo: "${api_no}",
    "...apiNo": "$PN{api_no}",
    apiNoRegion: "${api_no_region}",
    apiNoCountry: "${api_no_country}",
    apiNoTimeZone: "${api_no_timezone}",
    callId: "${callId}",
    appId: "${app_id}",
    keyPresses: "${___lastCollectKeys___}",
    numConferenceParticipants: "${conference.participants}",
    "...numConferenceParticipants": "$N{conference.participants}",
    callerNoSay: "$PN{phoneNo}",
    "...callerNoSay": "$PN{phoneNo}",
    apiNoSay: "$PN{from}",
    "...apiNoSay": "$PN{from}",
    keyPressesSay: "$N{___lastCollectKeys___}",
    "...keyPressesSay": "$N{___lastCollectKeys___}",
};
var VAR_MAP_KEYS = Object.keys(VAR_MAP);
var RE_FIND_ALL_VARS = /\${(\.+)?\w+([.\[][.a-zA-Z0-9\-_$'"\[\]]+)?}/g;
var RE_FIND_SESSION_DATA_VAR = /^\$(sessionData|webhookData|functionData)((?:.|\[)[a-zA-Z0-9_\-$'"\[\].]+)?$/;
var RE_FIND_LOCAL_VAR = /^\$(\w+)((?:.|\[)[a-zA-Z0-9_\-$'"\[\].]+)?$/;
var RE_FIND_ALL_LOCAL_VARS = /([^a-zA-Z0-9_$.\]])\$(?!(?:[PN+]*\{))(\w+)([^a-zA-Z0-9_$\{])/g;
var RE_ESCAPE_RE_CHARS = /[\-\[\]\/{}()*+?.\\\^$|]/g;
function parseVars(str, startIndex) {
    if (startIndex === void 0) { startIndex = 0; }
    var ccml = [], id = "___temp_str_var";
    str = " " + str + " ";
    if (RE_FIND_ALL_VARS.test(str)) {
        (str.match(RE_FIND_ALL_VARS) || [])
            .map(function (m) { return m.slice(2, -1); })
            .filter(function (m) { return !VAR_MAP[m]; })
            .forEach(function (m) {
            var _a = m.match(/^(\.*)(.+)/) || ["", "", ""], splits = _a[1], obj = _a[2];
            var splitsSuffix = splits ? ".toString().split(\"\").join(\",\")" : "";
            var expression = parseExpression("$" + obj);
            var varName = id + "_" + startIndex++ + "___";
            if (splitsSuffix) {
                str = str.replace(new RegExp("\\${(\\.+)" + escapeRegExp(obj) + "}", "g"), "${" + varName + "}");
            }
            else {
                str = str.replace(new RegExp("\\${" + escapeRegExp(obj) + "}", "g"), "${" + varName + "}");
            }
            ccml.push("<SET varName=\"" + varName + "\" export=\"false\" evaluate=\"true\"><![CDATA[ " + expression + splitsSuffix + " ]]></SET>");
        });
    }
    str = VAR_MAP_KEYS.reduce(function (p, c) { return p.replace(new RegExp("\\${" + c + "}", "g"), VAR_MAP[c]); }, str);
    return [str.trim(), ccml];
}
exports.parseVars = parseVars;
function parseAssignmentVar(v) {
    var match = v.trim().match(RE_FIND_SESSION_DATA_VAR);
    if (match !== null) {
        return ["___" + match[1] + "___", match[2], "___var_assign_temp___"];
    }
    match = v.trim().match(RE_FIND_LOCAL_VAR);
    if (match === null) {
        return;
    }
    return ["___localVar_" + match[1] + "___", match[2], "___var_assign_temp___"];
}
exports.parseAssignmentVar = parseAssignmentVar;
function parseExpression(exp) {
    exp = " " + exp + " ";
    exp = OBJ_MAP_KEYS.reduce(function (p, c) {
        [
            new RegExp("[^a-zA-Z0-9_\\$](\\$" + c + "[\\.\\[][\\.a-zA-Z0-9_\\-\\$'\"\\[\\]]+)[^a-zA-Z0-9_\\$]", "g"),
            new RegExp("[^a-zA-Z0-9_\\$](\\$" + c + ")[^a-zA-Z0-9_\\$]", "g"),
        ].forEach(function (re) {
            var match = re.exec(p);
            while (match !== null) {
                var m = match[1].replace("$" + c, "JSON.parse(" + OBJ_MAP[c] + ")");
                p = p.replace(match[1], m);
                match = re.exec(p);
            }
        });
        return p;
    }, exp);
    exp = VAR_MAP_KEYS.reduce(function (p, c) { return p.replace(new RegExp("[^a-zA-Z0-9_\\$](\\$" + c + ")[^a-zA-Z0-9_\\$]", "g"), " " + VAR_MAP[c] + " "); }, exp);
    var newExp = "";
    while (newExp !== exp) {
        newExp = exp;
        exp = exp.replace(RE_FIND_ALL_LOCAL_VARS, "$1(JSON.parse(${___localVar_$2___}))$3");
    }
    return exp.trim();
}
exports.parseExpression = parseExpression;
function escapeRegExp(str) {
    return str.replace(RE_ESCAPE_RE_CHARS, "\\$&");
}
//# sourceMappingURL=VarParser.js.map